//: #### Other pages
//:
//: * Demo for `colors` parser
//: * [Demo for `coredata` parser](CoreData-Demo)
//: * [Demo for `files` parser](Files-Demo)
//: * [Demo for `fonts` parser](Fonts-Demo)
//: * [Demo for `ib` parser](InterfaceBuilder-Demo)
//: * [Demo for `json` parser](JSON-Demo)
//: * [Demo for `plist` parser](Plist-Demo)
//: * [Demo for `strings` parser](Strings-Demo)
//: * [Demo for `xcassets` parser](XCAssets-Demo)
//: * [Demo for `yaml` parser](YAML-Demo)

//: #### Example of code generated by `colors` parser with "literals-swift5" template
//:  - Note: The `colors` parsers is primarily aimed to parse Android `colors.xml` files and text files.
//:          In most cases, you should prefer defining your colors in asset catalogs – as those support multiple variants for light/dark mode, P3 colorspace, and more – and use the `xcassets` parser instead to generate constants for those colors.

#if os(macOS)
  import AppKit
  internal enum ColorName { }
#elseif os(iOS) || os(tvOS) || os(watchOS)
  import UIKit
  internal enum ColorName { }
#endif

// swiftlint:disable superfluous_disable_command
// swiftlint:disable file_length

// MARK: - Colors

// swiftlint:disable identifier_name line_length type_body_length
internal extension ColorName {
  /// 0x339666ff (r: 51, g: 150, b: 102, a: 255)
  static let articleBody = #colorLiteral(red: 0.2, green: 0.588235, blue: 0.4, alpha: 1.0)
  /// 0xff66ccff (r: 255, g: 102, b: 204, a: 255)
  static let articleFootnote = #colorLiteral(red: 1.0, green: 0.4, blue: 0.8, alpha: 1.0)
  /// 0x33fe66ff (r: 51, g: 254, b: 102, a: 255)
  static let articleTitle = #colorLiteral(red: 0.2, green: 0.996078, blue: 0.4, alpha: 1.0)
  /// 0xffffffcc (r: 255, g: 255, b: 255, a: 204)
  static let `private` = #colorLiteral(red: 1.0, green: 1.0, blue: 1.0, alpha: 0.8)
}
// swiftlint:enable identifier_name line_length type_body_length

//: #### Usage Example

let view = UILabel(frame: .zero)

view.textColor = ColorName.articleBody
view.backgroundColor = ColorName.private
